package it.gotoandplay.smartfoxserver.admin;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.TimerTask;

public class AdminTaskExecutor extends TimerTask
{
  private LinkedList taskList;

  public AdminTaskExecutor()
  {
    this.taskList = new LinkedList();
  }

  public void addTask(ExecutableAdminTask eat)
  {
    synchronized (this.taskList)
    {
      this.taskList.add(eat);
    }
  }

  public void run()
  {
    if (this.taskList.size() > 0)
    {
      long now = System.currentTimeMillis();

      synchronized (this.taskList)
      {
        for (Iterator i = this.taskList.iterator(); i.hasNext(); )
        {
          ExecutableAdminTask task = (ExecutableAdminTask)i.next();

          if (now < task.getExecTime())
            break label97;
          task.execute();

          if (task.isLooping())
          {
            task.setExecTime(System.currentTimeMillis() + task.getDelay()); break label97:
          }

          label97: i.remove();
        }
      }
    }
  }
}