package it.gotoandplay.smartfoxserver.crypto;

import it.gotoandplay.smartfoxserver.SmartFoxServer;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.logging.Logger;

public class MD5
{
  private static MD5 _instance;
  private MessageDigest messageDigest;

  private MD5()
  {
    try
    {
      this.messageDigest = MessageDigest.getInstance("MD5");
    }
    catch (NoSuchAlgorithmException e)
    {
      SmartFoxServer.log.warning("Could not instantiate the MD5 Message Digest!");
    }
  }

  public static MD5 instance()
  {
    if (_instance == null)
      _instance = new MD5();

    return _instance;
  }

  public String getHash(String s)
  {
    byte[] data = s.getBytes();

    this.messageDigest.update(data);

    return toHexString(this.messageDigest.digest());
  }

  private String toHexString(byte[] byteData)
  {
    StringBuffer sb = new StringBuffer();

    for (int i = 0; i < byteData.length; ++i)
    {
      String hex = Integer.toHexString(byteData[i] & 0xFF);
      if (hex.length() == 1)
        hex = "0" + hex;

      sb.append(hex);
    }

    return sb.toString();
  }
}