package it.gotoandplay.smartfoxserver.data;

import it.gotoandplay.smartfoxserver.SmartFoxServer;
import it.gotoandplay.smartfoxserver.config.ConfigData;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.logging.Logger;

public class KickedUser
{
  private String ipAddr;
  private LinkedList kicks;

  public KickedUser(String ipAddr)
  {
    this.ipAddr = ipAddr;
    this.kicks = new LinkedList();
  }

  public String getIp()
  {
    return this.ipAddr;
  }

  public void addKick()
  {
    synchronized (this.kicks)
    {
      this.kicks.add(new Long(System.currentTimeMillis()));
    }
  }

  public void addBadWordKick()
  {
    synchronized (this.kicks)
    {
      this.kicks.add(new Long(-System.currentTimeMillis()));
    }
  }

  public long getLastKick()
  {
    return ((Long)this.kicks.getLast()).longValue();
  }

  public boolean isBannable()
  {
    boolean result = false;

    int floodCount = 0;
    int badWordCount = 0;

    synchronized (this.kicks)
    {
      for (Iterator i = this.kicks.iterator(); i.hasNext(); )
      {
        long t = ((Long)i.next()).longValue();

        if ((t > 0L) && (ConfigData.ANTIFLOOD_ACTIVE))
        {
          if (t < System.currentTimeMillis() - ConfigData.ANTIFLOOD_BAN_AFTER_TIMESPAN)
          {
            i.remove();
            SmartFoxServer.log.finer("Removed flood kick for ip-adr: " + getIp()); break label179:
          }

          ++floodCount; break label179:
        }

        if ((t >= 0L) || (!(ConfigData.BADWORDS_ACTIVE)))
          break label179;

        t = -t;

        if (t < System.currentTimeMillis() - ConfigData.BADWORDS_BAN_AFTER_TIMESPAN)
        {
          i.remove();
          SmartFoxServer.log.finer("Removed badwords kick for ip-adr: " + getIp()); break label179:
        }

        label179: ++badWordCount;
      }

      if ((floodCount >= ConfigData.ANTIFLOOD_BAN_AFTER_KICKS) && (ConfigData.ANTIFLOOD_ACTIVE))
        result = true;

      if ((badWordCount >= ConfigData.BADWORDS_BAN_AFTER_KICKS) && (ConfigData.BADWORDS_ACTIVE))
        result = true;

      return result;
    }
  }
}