package it.gotoandplay.smartfoxserver.data;

public class RoomVariable extends UserVariable
{
  private User owner;
  private boolean persistent;
  private boolean priv;

  public RoomVariable(String value, String type, User owner, boolean persistent, boolean priv)
  {
    super(value, type);

    this.owner = owner;
    this.persistent = persistent;
    this.priv = priv;
  }

  public boolean isPersistent()
  {
    return this.persistent;
  }

  public User getOwner()
  {
    return this.owner;
  }

  public boolean isPrivate()
  {
    return this.priv;
  }

  public void setPersistent(boolean b)
  {
    this.persistent = b;
  }

  public void setPrivate(boolean b)
  {
    this.priv = b;
  }

  public void setOwner(User who)
  {
    this.owner = who;
  }

  public boolean equals(Object o)
  {
    boolean b = false;
    RoomVariable rv = (RoomVariable)o;

    if ((rv.getValue().equals(this.value)) && 
      (rv.getType().equals(this.type)) && 
      (rv.isPersistent() == isPersistent()) && 
      (rv.isPrivate() == isPrivate()))
    {
      b = true;
    }

    return b;
  }

  public String toString()
  {
    StringBuffer sb = new StringBuffer("Var value: ").append(this.value);
    sb.append(", priv: ").append(isPrivate()).append(", pers: ").append(isPersistent());
    sb.append(", owner: ").append(this.owner);

    return sb.toString();
  }
}