package it.gotoandplay.smartfoxserver.data;

import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public class ZoneManager
  implements IZoneManager
{
  private Map<String, Zone> zones;

  public ZoneManager()
  {
    this.zones = new ConcurrentHashMap();
  }

  public void init(Object param)
  {
  }

  public void destroy(Object param)
  {
    Collection zoneList = this.zones.values();

    for (Iterator it = zoneList.iterator(); it.hasNext(); )
    {
      Zone zone = (Zone)it.next();
      zone.destroy(null);
    }
  }

  public Zone getZone(String zoneName)
  {
    return ((Zone)this.zones.get(zoneName));
  }

  public int getZoneCount()
  {
    return this.zones.size();
  }

  public List<Zone> getZoneList()
  {
    return new LinkedList(this.zones.values());
  }

  public void setZone(String zoneName, Zone zone)
  {
    this.zones.put(zoneName, zone);
  }
}