package it.gotoandplay.smartfoxserver.data.buddylist;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public class OfflineBuddyVariablesManager
  implements IOfflineVariableManager
{
  private int maxCacheSize;
  private int evictionSize;
  private String zoneName;
  private Map<String, Map<String, String>> varCache;

  public OfflineBuddyVariablesManager()
  {
    this.maxCacheSize = 200;
    this.evictionSize = 10;

    this.varCache = new ConcurrentHashMap();
  }

  public OfflineBuddyVariablesManager(int maxCacheSize)
  {
    this.maxCacheSize = maxCacheSize;
  }

  public Map<String, String> getVariables(String buddyName)
  {
    return ((Map)this.varCache.get(buddyName));
  }

  public void setVariables(String owner, Map<String, String> vars)
  {
    if (vars != null)
      this.varCache.put(owner, vars);
  }

  public void removeVariables(String owner)
  {
    this.varCache.remove(owner);
  }

  public String getXmlVariables(String owner)
  {
    return null;
  }

  public Map<String, Map<String, String>> getCache()
  {
    return this.varCache;
  }

  private void monitorCacheSize()
  {
    this.varCache.size();
  }
}