package it.gotoandplay.smartfoxserver.data.buddylist.persistence;

import it.gotoandplay.smartfoxserver.SmartFoxServer;
import it.gotoandplay.smartfoxserver.data.User;
import it.gotoandplay.smartfoxserver.data.Zone;
import it.gotoandplay.smartfoxserver.data.buddylist.BuddyListManager;
import it.gotoandplay.smartfoxserver.data.buddylist.StorableBuddyList;
import java.io.PrintStream;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.logging.Logger;

public class AbstractBuddyPersister
  implements IBuddyListPersister
{
  protected String zoneName;

  public void setZoneName(String zoneName)
  {
    this.zoneName = zoneName;
  }

  protected Zone getCurrentZone()
  {
    return SmartFoxServer.getInstance().getZone(this.zoneName);
  }

  protected BuddyListManager getBuddyManager()
  {
    return SmartFoxServer.getInstance().getZone(this.zoneName).getBuddyManager();
  }

  public void init(Object param)
  {
  }

  public void destroy(Object param)
  {
  }

  public StorableBuddyList loadList(String userName)
  {
    return null;
  }

  public Map<String, String> getOfflineVariables(String userName)
  {
    throw new UnsupportedOperationException("Method not available. It should be implemented by the custom persister sub-class!");
  }

  public boolean removeOfflineBuddy(String owner, String buddyName)
  {
    throw new UnsupportedOperationException("Method not available. It should be implemented by the custom persister sub-class!");
  }

  public void saveAll(Map<String, StorableBuddyList> buddyLists)
  {
    long t1 = System.currentTimeMillis();

    Zone z = SmartFoxServer.getInstance().getZone(this.zoneName);
    List allUsers = z.getUserList();

    for (Iterator iterator = allUsers.iterator(); iterator.hasNext(); )
    {
      User user = (User)iterator.next();

      if ((user == null) || (!(user.buddyListChanged())))
        break label108;
      String userName = user.getName();
      StorableBuddyList bList = (StorableBuddyList)buddyLists.get(userName);

      if (bList == null)
        break label108;
      saveList(userName, (StorableBuddyList)buddyLists.get(userName));
      label108: user.setBuddyListSaved();
    }

    long t2 = System.currentTimeMillis();

    SmartFoxServer.log.fine("Buddy Lists Autosave done in " + (t2 - t1) + "ms.");
  }

  public boolean saveList(String userName, StorableBuddyList buddyList)
  {
    System.out.println("Inside abstract class... you should subclass it.");
    return false;
  }
}