package it.gotoandplay.smartfoxserver.data.buddylist.tasks;

import it.gotoandplay.smartfoxserver.data.Zone;
import it.gotoandplay.smartfoxserver.data.buddylist.BuddyListManager;
import it.gotoandplay.smartfoxserver.util.scheduling.ITaskHandler;
import it.gotoandplay.smartfoxserver.util.scheduling.Task;
import java.util.Collection;
import java.util.Iterator;
import java.util.Map;

public class BuddyListTaskHandler
  implements ITaskHandler
{
  public void doTask(Task task)
    throws Exception
  {
    if (task.id == BuddyTasks.AUTO_SAVE) {
      handleAutoSave(task);
    }
    else if (task.id == BuddyTasks.CLEAN_PERMISSIONS)
      handleCleanPermissions(task);
  }

  private void handleCleanPermissions(Task task)
  {
    Map zones = (Map)task.parameters.get("zones");

    synchronized (zones)
    {
      for (Iterator it = zones.values().iterator(); it.hasNext(); )
      {
        Zone zone = (Zone)it.next();

        if (!(zone.hasBuddyList())) break label63;
        label63: zone.getBuddyManager().clearExpiredPermissionRequests();
      }
    }
  }

  private void handleAutoSave(Task task)
  {
    Map zones = (Map)task.parameters.get("zones");

    synchronized (zones)
    {
      for (Iterator it = zones.values().iterator(); it.hasNext(); )
      {
        Zone zone = (Zone)it.next();

        if (!(zone.hasBuddyList())) break label63;
        label63: zone.getBuddyManager().saveAllBuddyLists();
      }
    }
  }
}