package it.gotoandplay.smartfoxserver.db;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DataRow
{
  public static final int DATAROW_INTKEY = 0;
  public static final int DATAROW_STRINGKEY = 1;
  private int type;
  private HashMap hm;
  private ArrayList al;

  public DataRow()
  {
    this(0);
  }

  public DataRow(int type)
  {
    this.type = type;

    if (type == 0)
      this.al = new ArrayList();
    else
      this.hm = new HashMap();
  }

  public void addItem(String s)
  {
    if (this.al != null)
      this.al.add(s);
  }

  public void addItem(String key, String s)
  {
    if (this.hm != null)
      this.hm.put(key, s);
  }

  public String getItem(int key)
  {
    String s = null;
    try
    {
      if (this.al == null)
        break label25;
      s = (String)this.al.get(key);
    }
    catch (IndexOutOfBoundsException localIndexOutOfBoundsException)
    {
    }

    label25: return s;
  }

  public String getItem(String key)
  {
    if (this.hm != null)
      return ((String)this.hm.get(key));

    return null;
  }

  public int getType()
  {
    return this.type;
  }

  public Map getDataAsMap()
  {
    return this.hm;
  }

  public List getDataAsList()
  {
    return this.al;
  }

  public Object getData()
  {
    Object o = null;

    if (this.type == 0)
      o = getDataAsList();
    else
      o = getDataAsMap();

    return o;
  }
}