package it.gotoandplay.smartfoxserver.extensions.examples;

import it.gotoandplay.smartfoxserver.data.User;
import it.gotoandplay.smartfoxserver.data.Zone;
import it.gotoandplay.smartfoxserver.db.DataRow;
import it.gotoandplay.smartfoxserver.db.DbManager;
import it.gotoandplay.smartfoxserver.events.InternalEventObject;
import it.gotoandplay.smartfoxserver.extensions.AbstractExtension;
import it.gotoandplay.smartfoxserver.extensions.ExtensionHelper;
import it.gotoandplay.smartfoxserver.lib.ActionscriptObject;
import java.util.ArrayList;
import java.util.LinkedList;

public class SimpleDbExtension extends AbstractExtension
{
  private ExtensionHelper helper;
  private DbManager db;
  private Zone currZone;

  public void init()
  {
    this.helper = ExtensionHelper.instance();

    this.currZone = this.helper.getZone(getOwnerZone());

    this.db = this.currZone.dbManager;
  }

  public void destroy()
  {
    this.db = null;
  }

  public void handleRequest(String cmd, ActionscriptObject ao, User u, int fromRoom)
  {
    if (cmd.equals("getData"));
    String sql = "SELECT * FROM contacts ORDER BY name";

    ArrayList queryRes = this.db.executeQuery(sql);

    ActionscriptObject response = new ActionscriptObject();

    response.put("_cmd", "getData");

    ActionscriptObject db_array = new ActionscriptObject();

    if ((queryRes != null) && (queryRes.size() > 0))
    {
      for (int i = 0; i < queryRes.size(); ++i)
      {
        DataRow row = (DataRow)queryRes.get(i);

        ActionscriptObject as_obj = new ActionscriptObject();

        as_obj.put("name", row.getItem("name"));
        as_obj.put("location", row.getItem("location"));
        as_obj.put("email", row.getItem("email"));

        db_array.put(i, as_obj);
      }

      response.put("db", db_array);
    }
    else {
      trace("DB Query failed");
    }

    LinkedList recipients = new LinkedList();
    recipients.add(u.getChannel());

    sendResponse(response, fromRoom, u, recipients);
  }

  public void handleRequest(String cmd, String[] params, User u, int fromRoom)
  {
  }

  public void handleInternalEvent(InternalEventObject ieo)
  {
  }
}