package it.gotoandplay.smartfoxserver.lib;

import it.gotoandplay.smartfoxserver.SmartFoxServer;
import java.nio.channels.SocketChannel;
import java.util.LinkedList;
import java.util.logging.Logger;

public class ChannelQueue
{
  Logger log = SmartFoxServer.log;
  private LinkedList events;
  private int count = 0;

  public ChannelQueue(String name)
  {
    this.events = new LinkedList();
  }

  public synchronized void enQueue(SocketChannel chan)
  {
    this.events.addLast(chan);
    super.notifyAll();
  }

  public synchronized SocketChannel deQueue()
    throws InterruptedException
  {
    while (this.events.size() == 0)
    {
      this.count += 1;

      super.wait();
      this.count -= 1;
    }

    SocketChannel chan = (SocketChannel)this.events.removeFirst();

    return chan;
  }

  public synchronized int size()
  {
    return this.events.size();
  }
}