package it.gotoandplay.smartfoxserver.lib;

import it.gotoandplay.smartfoxserver.SmartFoxServer;
import java.util.LinkedList;
import java.util.logging.Logger;

public class EventQueue
{
  Logger log = SmartFoxServer.log;
  private LinkedList events;
  private int count = 0;

  public EventQueue(String name)
  {
    this.events = new LinkedList();
  }

  public synchronized void enQueue(ServerEvent event)
  {
    this.events.addLast(event);
    super.notifyAll();
  }

  public synchronized void adminEnQueue(ServerEvent event)
  {
    this.events.addFirst(event);
    super.notifyAll();
  }

  public synchronized ServerEvent deQueue()
    throws InterruptedException
  {
    while (this.events.size() == 0)
    {
      this.count += 1;

      super.wait();
      this.count -= 1;
    }

    ServerEvent e = (ServerEvent)this.events.removeFirst();

    return e;
  }

  public synchronized int size()
  {
    return this.events.size();
  }
}