package it.gotoandplay.smartfoxserver.lib;

import it.gotoandplay.smartfoxserver.SmartFoxServer;
import it.gotoandplay.smartfoxserver.data.Zone;
import it.gotoandplay.smartfoxserver.extensions.ExtensionManager;
import java.util.Iterator;
import java.util.LinkedList;

public class ExtensionAutoReloader
  implements Runnable
{
  private boolean running = false;
  private static final long SLEEP_TIME = 1000L;
  private SmartFoxServer sfs;

  public ExtensionAutoReloader()
  {
    this.running = true;
    this.sfs = SmartFoxServer.getInstance();
  }

  public void run()
  {
    while ((this.running) && (!(SmartFoxServer.IS_SHUTTING_DOWN)))
    {
      LinkedList zones = this.sfs.getAllZones();
      Zone z = null;

      for (i = zones.iterator(); i.hasNext(); )
      {
        z = (Zone)i.next();

        if (!(z.isAutoReloadExtensions()))
          break label45;
        label45: z.getExtManager().automagicReload();
      }

      try
      {
        Thread.sleep(1000L);
      }
      catch (java.lang.InterruptedException i)
      {
      }
    }
  }

  public void halt()
  {
    this.running = false;
  }
}