package it.gotoandplay.smartfoxserver.lib;

import java.nio.channels.SocketChannel;
import java.util.LinkedList;
import net.n3.nanoxml.IXMLElement;
import org.json.JSONObject;

public class ServerEvent
{
  IXMLElement xmlMsg;
  String strMsg;
  JSONObject jsonObj;
  SocketChannel sender;
  LinkedList recipients;
  private boolean isXml;
  private boolean isJson;

  public ServerEvent(IXMLElement msg, SocketChannel sender)
  {
    this.xmlMsg = msg;
    this.sender = sender;
    this.isXml = true;
    this.isJson = false;
  }

  public ServerEvent(String msg, SocketChannel sender)
  {
    this.strMsg = msg;
    this.sender = sender;
    this.isXml = false;
    this.isJson = false;
  }

  public ServerEvent(JSONObject msg, SocketChannel sender)
  {
    this.jsonObj = msg;
    this.sender = sender;
    this.isXml = false;
    this.isJson = true;
  }

  public ServerEvent(String msg, SocketChannel sender, LinkedList recipients)
  {
    this.strMsg = msg;
    this.sender = sender;
    this.recipients = recipients;
  }

  public IXMLElement getXmlMsg()
  {
    return this.xmlMsg;
  }

  public JSONObject getJsonMsg()
  {
    return this.jsonObj;
  }

  public String getStrMsg()
  {
    return this.strMsg;
  }

  public LinkedList getRecipients()
  {
    return this.recipients;
  }

  public SocketChannel getSenderChannel()
  {
    return this.sender;
  }

  public boolean getIsXml()
  {
    return this.isXml;
  }

  public boolean getIsJson()
  {
    return this.isJson;
  }
}