package it.gotoandplay.smartfoxserver.lib.http;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

public class LoadVars
  implements Runnable
{
  public static final int METHOD_NONE = 0;
  public static final int METHOD_GET = 1;
  public static final int METHOD_POST = 2;
  private static int tCount = 0;
  private Map inParams;
  private Map outParams;
  private Thread thread;
  private int sendMethod;
  private String url;
  private ILoadVarsListener listener;
  private boolean readData;

  public LoadVars(HashMap map, int method)
  {
    this.inParams = new HashMap();
    this.outParams = map;
    this.url = null;
    this.sendMethod = method;
    this.readData = false;

    this.thread = new Thread(this, "loadvar_" + (tCount++));
  }

  public void load(String url)
  {
    this.url = url;
    this.readData = true;
    this.thread.start();
  }

  public void send(String url)
  {
    this.url = url;
    this.thread.start();
  }

  public void sendAndLoad(String url)
  {
    load(url);
  }

  public void setListener(ILoadVarsListener listener)
  {
    this.listener = listener;
  }

  public ILoadVarsListener getListener()
  {
    return this.listener;
  }

  public void run()
  {
    boolean success = false;
    String errorMsg = "";
    try
    {
      URL theUrl = new URL(this.url);
      URLConnection conn = theUrl.openConnection();

      conn.setDoInput(true);

      conn.setDoOutput(this.sendMethod == 2);

      conn.setUseCaches(false);

      if (this.sendMethod == 2)
      {
        String postData = map2str(this.outParams);

        conn.setRequestProperty("CONTENT_LENGTH", String.valueOf(postData.length()));

        OutputStream os = conn.getOutputStream();
        OutputStreamWriter osw = new OutputStreamWriter(os);

        osw.write(postData);
        osw.flush();
        osw.close();
      }

      if (this.readData)
      {
        InputStream is = conn.getInputStream();
        InputStreamReader isr = new InputStreamReader(is);
        BufferedReader br = new BufferedReader(isr);

        String lineOfData = null;
        StringBuffer sb = new StringBuffer();

        while ((lineOfData = br.readLine()) != null)
        {
          sb.append(lineOfData);
        }

        this.inParams = str2map(sb.toString());
        success = true; break label307:
      }

      success = true;
    }
    catch (MalformedURLException mue)
    {
      errorMsg = "Malformed url: " + this.url;
    }
    catch (FileNotFoundException fnfe)
    {
      errorMsg = "404 error, page not found: " + this.url;
    }
    catch (IOException ioe)
    {
      errorMsg = "I/O Error: " + ioe.getMessage();
    }
    catch (Exception e)
    {
      errorMsg = "Generic exception: " + e.getMessage();
    }

    label307: this.listener.onLoad(success, this.inParams, errorMsg);
  }

  private Map str2map(String str)
  {
    HashMap map = new HashMap();
    try
    {
      vars = str.split("&");

      for (int i = 0; i < vars.length; ++i)
      {
        String[] var = vars[i].split("=");

        if (var.length >= 2)
          map.put(var[0], URLDecoder.decode(var[1], "UTF-8"));

      }

    }
    catch (java.io.UnsupportedEncodingException vars)
    {
    }

    return map;
  }

  private String map2str(Map map)
  {
    Set keys = map.keySet();
    StringBuffer sb = new StringBuffer();

    String key = null;
    String val = null;
    try
    {
      for (i = keys.iterator(); i.hasNext(); )
      {
        key = (String)i.next();
        val = (String)map.get(key);

        sb.append(key).append("=").append(URLEncoder.encode(val, "UTF-8")).append("&");
      }

    }
    catch (java.io.UnsupportedEncodingException i)
    {
    }

    return sb.toString();
  }
}