package it.gotoandplay.smartfoxserver.py;

import it.gotoandplay.smartfoxserver.lib.IService;
import it.gotoandplay.smartfoxserver.lib.SmartFoxLib;
import java.io.IOException;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import org.python.util.PythonInterpreter;

public class PyHelper
  implements IService
{
  private static final String CORE_CLASS = "lib/pycore/core.py";
  private PythonInterpreter pyRunTime;
  private Map<String, IPyClass> classes;

  public void init(Object param)
  {
    this.pyRunTime = new PythonInterpreter();
    this.classes = new ConcurrentHashMap();
    try
    {
      loadCore();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(-1);
    }
  }

  public void destroy(Object param)
  {
  }

  public IPyClass getPyClass(String className)
  {
    return ((IPyClass)this.classes.get(className));
  }

  public IPyClass getNewInstance(String className)
  {
    return null;
  }

  private void loadCore() throws IOException
  {
    String pyCode = new String(SmartFoxLib.readFileInClassPath("lib/pycore/core.py"));
    this.pyRunTime.exec(pyCode);

    this.pyRunTime.set("__classes__", this.classes);
    this.pyRunTime.exec("init()");
  }
}