package it.gotoandplay.smartfoxserver.webserver;

import it.gotoandplay.smartfoxserver.SmartFoxServer;
import it.gotoandplay.smartfoxserver.data.User;
import java.net.InetAddress;
import java.net.Socket;
import java.nio.channels.SocketChannel;
import java.util.HashMap;
import java.util.Map;

public class WebHelper
{
  public static final int ONE_DAY = 86400000;
  public static final int ONE_HOUR = 3600000;
  public static final int ONE_MINUTE = 60000;
  public static final int ONE_SECOND = 1000;

  public static Map getServerStatus()
  {
    SmartFoxServer sfs = SmartFoxServer.getInstance();
    Map map = new HashMap();

    map.put("version", sfs.getVersion());
    map.put("zones", new Integer(sfs.getZoneNumber()));
    map.put("users", new Integer(sfs.getGlobalUserCount()));
    map.put("rooms", new Integer(sfs.getRoomNumber()));
    map.put("uptime", getUptime());

    return map;
  }

  public static boolean verifyUploadUser(String uid, String nick, String ipAdr)
  {
    boolean res = false;

    Integer id = null;
    try { id = new Integer(uid); } catch (NumberFormatException localNumberFormatException) {
    }
    User u = SmartFoxServer.getInstance().getUserById(id);

    if ((u != null) && 
      (u.getName().equals(nick)))
    {
      try
      {
        if (!(u.getChannel().socket().getInetAddress().getHostAddress().equals(ipAdr))) break label75;
        res = true;
      }
      catch (NullPointerException localNullPointerException)
      {
      }

    }

    label75: return res;
  }

  private static String getUptime()
  {
    StringBuffer result = new StringBuffer();

    long now = System.currentTimeMillis();
    long start = SmartFoxServer.getInstance().getServerStartTime();
    long temp = 0L;

    long elapsed = now - start;
    int days = (int)Math.floor(elapsed / 86400000L);

    temp = 86400000L * days;

    elapsed -= temp;
    int hours = (int)Math.floor(elapsed / 3600000L);

    temp = 3600000 * hours;
    elapsed -= temp;
    int minutes = (int)Math.floor(elapsed / 60000L);

    String s_days = String.valueOf(days);

    for (int i = 0; i < 4 - s_days.length(); ++i) {
      result.append("0");
    }

    result.append(s_days);
    result.append(":");

    if (hours < 10)
      result.append("0");

    result.append(hours);
    result.append(":");

    if (minutes < 10)
      result.append("0");

    result.append(minutes);

    return result.toString();
  }
}